'use strict';

const Sequelize = require('sequelize');

const chai = require('chai');
const mocha = require('mocha');
const should = require('should');
const asyncp = require('paradox-asyncp');

const Dblize = require('../index');
const _ = require('lodash');
const Promise = require('bluebird');

describe('MySQL', function() {
    this.timeout(10 * 1000);

    let conn;
    let Model;

    /* -------------------------------------------------------------------------
     * Before
     * ---------------------------------------------------------------------- */

    before(function() {
        conn = new Sequelize('test', 'root', '', {
            dialect: 'mysql',
            logging: false,
        });

        Model = conn.define('test_model_test', {
            a: {
                type: Sequelize.INTEGER,
                allowNull: false,
                validate: {
                    isNumeric: true,
                    isInt: true,
                }
                // defaultValue: 'defaultVal',
                // get() {
                //     return "123123";
                // }
            },
        });

        return Model.sync();
    });

    /* -------------------------------------------------------------------------
     * Create
     * ---------------------------------------------------------------------- */

    it('findOne', () => {
        let instance = Model.build({
            a: '1234',
        });

        console.info(instance.dataValues);
        console.info(instance.get({
            raw: true,
            plain: true,
        }));
        console.info(instance.get());
        console.info(instance.a);
        console.info(instance.get('a'));
        console.info(instance.getDataValue('a'));

        instance.validate()
            .then(
                console.info,
                console.error
            )
    });
});